import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class DocumentGraph {
    Manager M;
    public DocumentGraph(Manager MM) {
	this.M=MM;
    }


    public void AGP_info() {

	String S="plot controls";

S=S+"\n\nThis control panel specifies what you plot in the Arithmetic Graph window.  If you don't know what the arithmetic graph is, you can read the documentation for the Arithmetic Graph Window.  In brief, the arithmetic graph is a 2-dimensional plot which encodes the dynamics of the fundamental return map for the outer billiards map.";

S=S+"\n\nNow I'll suppose you know what the arithmetic graph is. Once you have set the option you like, just push 'go' and see what happens. Note: many grid points in the Arithmetic Graph window are not in the arithmetic graph: they have trivial orbits. For these points, nothing will happen if you press 'go'.  You can also select and activate some of the options using the keyboard.  For instance, pressing H is equivalent to selecting the 'forward' option and then pressing 'go'.  The relevant key letter is written after the option on the control panel. ";

	S=S+"\n\nforward: The forward option plots the forward orbit of the selected point in the Arithmetic Graph window. You control the number of iterates (always a power of 2 with our interface) using the arrow key labelled 'length'."; 

	S=S+"\n\nbasic: The basic option plots both the forwards and backwards orbit of the selected point in the Arithmetic Graph window. You control the number of iterates (always a power of 2 with our interface) using the arrow key labelled 'length'."; 

	S=S+"\n\nbackward: The backward option plots the backward orbit of the selected point in the Arithmetic Graph window. You control the number of iterates as in the forward case."; 

	S=S+"\n\nperiod: Let p/q be the rational parameter you have selected. When pq is even, the fundamental orbit is a closed embedded polygon.  This option plots this polygon.  When pq is odd, the fundamental orbit is an infinite embedded periodic curve.  This option plots 2 periods of that curve in this case.  The fundamental orbit is the orbit of the point (1/q,1).";

	S=S+"\n\npivot arc: This routine plots the pivot arc.  The pivot arc is the smallest arc of the fundamental component of the arithmetic graph that contains all the low vertices.  A vertex (m,n) is low if the baseline separates (m,n) from (m,n-1).  The pivot arc is discussed in great detail in the monograph.";
	S=S+"\n\nmonster: This plot works for an even rational paramter A=p/q.  There is a unique sequence A1,A2,...A, where the denominators increase, successive fractions are Farey-related, and the last term is A. This routine plots, all at the same time, the arithmetic graphs corresponding to these components. Unlike other routines, the colors are fixed in advance for the plot.  This plot does nothing for odd rationals.";

	S=S+"\n\nlow -- even:  A low vertex (m,n) is a vertex that is within 1 vertical unit of the baseline, the line of slope -A through the origin.  the parity of such a vertex is defined to be the parity of m+n.  A low component is a component of the arithmetic graph that contains a low vertex.  According to a result in our monograph, all the low vertices on a low component have the same parity. Thus, we can speak of the parity of a low component.  This routine plots one period's worth of all the low components of even parity.";



	S=S+"\n\nlow -- odd:  This routine plots one period's worth of the low components of odd parity.  To get a nice picture, you should plot the even low components and the odd low components with different colors.";

	S=S+"\n\nblock1: This option lets you plot all the orbits within a standard rectangle. The rectangle is centered on the point in the window you have selected.  If you select nothing, then the default is (0,0).";


	S=S+"\n\nblock2: This option lets you plot all the orbits within a certain parallelogram whose sides are parallel to the wall and ceiling lines of the hexagrid.  The two arrow keys above this panel control the size of this rectangle.  The rectangle is centered on the point in the window you have selected.  If you select nothing, then the default is (0,0).";

	S=S+"\n\ncompare: This option works like the block plots, in that it considers the return map for all points within a parallelogram.  However, the compare option considers the block plots for two parameters at the same time, and then records the grid points where the two plots differ.  To get this plot to work, you should save a rational value using the monograph mode of the shape entry system, and then select a nearby second parameter.  The inferior predecessor is always a good choice.  In general, if you select parameters p1/q1 and p2/q2, you you would like the difference |p1/q1-p2/q2| to be proportional to 1/q^2, where q=min(q1,q2).  The smaller the constant of proportionality, the larger the region of agreement. To best appreciate this option, you should turn on the 'dio lemma' option on the 'regions' control panel.";


	M.E.setExplain(S);

	M.E.repaint();
    }


    public void style_info() {
	String S="drawing style";
	S=S+"\n\nThis control panel specifies the drawing style. There are 3 options:";
	S=S+"\n\noutline: This just shows the arithmetic graph itself.";
	S=S+"\n\nsolid: When orbits are plotted individually, as with the 'forwards' and 'backwards' plotting options, this fills in the whole component, provided that it has been completely plotted.  This option works best with the stable orbits, which are polygons.  For the unstable orbits, the picture is not as nice.";

	S=S+"\n\nsolid+white: This does the same as the solid option, but adds a white outline.";

	S=S+"\n\nThe solid option is best used with semi-transparent colors.  Otherwise, some parts of the picture might block other parts.  For the purposes of understanding the basic structure of the arithmetic graph, it is better to use the outline option.  The other options are added for artistic effect.";
	M.E.setExplain(S);
	M.E.repaint();
    }


    public void scale_info() {
	String S="scaling";
	S=S+"\n\nThis control panel specifies the way the pictures in the arithmetic graph window are normalized.";
	S=S+"\n\nintegral: This is the usual mode, where the Z+Z lattice is a square grid. The entire monograph is written so as to be compatible with this scaling, and all the features of the arithmetic graph window work with this scaling.";

	S=S+"\n\naffine: This mode applies an affine transformation to the picture so that the basis (V,W) from the monograph generates a square grid.  This mode is useful when you want to explore the fractal structure of the arithmetic graphs.";
	M.E.setExplain(S);
	M.E.repaint();
    }



    public void arithmeticGraphInfo() {

	String S="arithmetic graph window";
	
        S=S+"\n\nThis window draws the arithmetic graph. You activate controls for this window by selecting the 'graph' option on the red 'controls' control panel.  Here we will describe the arithmetic graph, and also explain how you interact with this window";

	S=S+"\n\nThere is a single real number A that controls the shape of the kite. Let R denote the union of the two rays emanating from the top and bottom vertices of the kite and pointing in the positive X direction.  The point (a,b) in the grid on this window corresponds to the points on R of the form";

	S=S+"\n\n(T(a,b),1) and (T(a,b),-1) \n\nwhere T(a,b)=2aA+2b+(e)";

	S=S+"\n\nHere (e) is an infinitesimally small positive value.  In our computations, we take e=.0000001.  The point here is to make sure that we are computing well-defined orbits.";

S=S+"\n\nWe apply the outer billiards map a number of times until our point returns to a point on R, and this point necessarily  corresponds to some T(a0,b0).   We also apply the inverse map a number of times to arrive at a point T(a1,b1).   We connect (a,b) to both (a0,b0) and (a1,b1).  This gives us a small part of the arithmetic graph.  Doing this for all points in the grid gives us the whole arithmetic graph.  The 'block plot' option on the Arithmetic Graph Control Panel makes this plot.";

	S=S+"\n\nAlternatively, we can trace out an orbit by starting with (a,b), then moving to (a1,b1), then moving to a new point (a2,b2) connected to (a1,b1), and so on.  This would give us a kind of 2D plot of the return map.  We could also connect (a,b) to (a0,b0), etc., working our way backwards.  This would give us a kind of 2D plot of the backwards return map.  The 'forwards' and 'backwards' options on the Arithmetic Graph Control Panel let you make this kind of plot, once you have selected (a,b).";

	S=S+"\n\nYou can interact with the Arithmetic Graph window in several ways.  First of all, you can click on grid points, as we already mentioned.  You select points using the middle mouse button. You can scale the window using the left and right mouse buttons. You can resize the window by dragging on the lower left corner.  You can move the selected point using the arrow keys in the upper left corner.  You can also enter a point numerically using the keyboard.";

	S=S+"\n\nThere are a few other auxilliary controls on the top portion of the window.  Once you select a component of the arithmetic graph, you can manipulate it in the following way:";
	S=S+"\n\ndelete: You can delete the component by pushing the delete button.";
	S=S+"\n\nreflect: There is a natural basis for the plane related to the kite with parameter A=p/q.  This basis is given by the vectors\n\n V=(q,-p) and W=(p,((p+q)^2-2p^2)/(2q)). \n\nThe linear part of the reflection maps V to -V and W to W.  There is also a translation part that maps (0,0) to the point (p',q') where pq'-qp'=1 and q'<q.  This affine reflection is not an exact symmetry of the arithmetic graph, but it maps the arithmetic graph into a small tubular neighborhood of itself.";

	M.E.setExplain(S);
	M.E.repaint();
    }


    public void pmarkerInfo() {}

    public void lineInfo() {
	String S="auxilliary lines";

	S=S+"\n\nThis control panel manages the drawing of some additional lines over the arithmetic graph.  These lines have a role that is similar to the hexagrid.  They control some of the structure of the arithmetic graph.";

	S=S+"\n\nbarrier: This line is described in the Barrier Theorem in the monograph.  Suppose that p2/q2 is an even rational. Then there is a unique odd rational p1/q1 such that |p1q2-p2q1|=1 and q1<q2.  The barrier line is parallel to the baseline of the arithmetic graph and contains the point (0,x/2) where x=p1+q1.  Within one period, the arithmetic graph only crosses the barrier line twice.  The barrier line plays a role similar to the ceiling lines in the hexagrid, except that the barrier line is an imperfect barrier whereas the ceiling lines are perfect barriers.";

	S=S+"\n\niota(wall):  This line plays a role similar to the wall lines of the hexagrid.  In fact, this line is the image of one of the wall lines under a certain rotational symmetry of the arithmetic graph.   This rotational symmetry is described in the monograph.  In the monograph, we call this symmetry iota.  To best appreciate this line, you should turn on the 'decomp' display on the 'regions' control panel";

	S=S+"\n\nsymm line:  This is a line of near bilateral symmetry for the graph.  This near bilateral symmetry is discussed in the monograph.  The symmetry iota mentioned above is a rotation by 180 degrees about a point extremely close to where this symmetry line meets the baseline of the graph.   To further appreciate this line, you should turn on the 'decomp' display.";


	S=S+"\n\nLike the other control panels currently in view, this control panel has 2 buttons beside each object.  The left button controls the color and the right button toggles the display.";

	M.E.setExplain(S);
	M.E.repaint();
    }




    public void basicInfo() {
	String S="basic settings";

	S=S+"\n\nThis control panel manages the basic settings on the arithmetic graph";
	S=S+"\n\nbackground color.  This is the background color on the arithmetic graph window";
	S=S+"\n\ncoordinate axes.  This toggles the display of coordinate axes on the arithmetic graph window";
	S=S+"\n\nthe Z+Z integer grid.  The arithmetic graph has its vertices in the integer lattice.  This toggles the display of a part of this lattice.  The lattice is about 80x80, and automatically centers on any point you click.";
	S=S+"\n\nthe baseline: this is the line of slope -A through the origin. As explained in the monograph, we technically define the baseline to be the line of slope -A through the point (0,-e), where e is an infinitesimally small positive number.";
	S=S+"\n\nrational: This causes the current rational to be displayed in large font on the arithmetic graph window.";
	S=S+"\n\nmarker: This is a little square that marks the location of the current selected point on the arithmetic graph window.  You should probably always keep this on.";
	S=S+"\n\nLike the some of the other control panels currently in view, this control panel has 2 buttons beside each object.  The left button controls the color and the right button toggles the display.  The one exception to this rule is the 'bgcolor' entry.  Here, the right button does nothing.";

	M.E.setExplain(S);
	M.E.repaint();
    }


    public void hexInfo() {
	String S="hexagrid";

	S=S+"\n\nThis control panel manages the hexagrid. The hexagrid, a union 6 infinite families of parallel lines,. controls some of the large scale structure of the arithmetic graph. You can either display the hexagrid all at once, or else select which families you want to see.  The hexagrid is described in detail in my monograph, in the Hexagrid Theorem.";

	S=S+"\n\nThe first 2 families together comprise the room grid.  The first family comprises the ceilings and the second family comprises the walls.  The arithmetic graph never crosses a ceiling line.  The arithmetic graph can only cross the wall lines at certain prescribed places, called doors.  The lines of the room grid are parallel to the diagonals of the arithmetic kite.  The 'regions' control panel lets you see the arithmetic kite.";

	S=S+"\n\nThe last 4 families together comprise the door grid.  The doors are places where the door grid intersects the walls.  The lines of the door grid are all parallel to various sides of the aritmetic kite.";

	S=S+"\n\nLike the other control panels currently in view, this control panel has 2 buttons beside each object.  The left button controls the color and the right button toggles the display.";

	M.E.setExplain(S);
	M.E.repaint();
    }






    public void regionInfo() {

	String S="special regions";

	S=S+"\n\nThis control panel manages some regions associated to the arithmetic graph.";

	S=S+"\n\noutline: This is not an object.  Rather the left button controls the outline color of the remaining objects.";

	S=S+"\n\nroom:  This is the parallelogram from the Room Lemma in the monograph.  The arithmetic graph only crosses the room at its bottom two corners.";

	S=S+"\n\ndecomp: This is the union of two parallelograms from the Decomposition Theorem in the monograph.  One period of the main component of the arithmetic graph is contained in the union of these two parallelograms. You should plot the arithmetic graph using the 'period' option to see the connection.";

	S=S+"\n\ndecomp+: This option displays 10 periods of the parallelograms from the Decomposition Theorem.";

	S=S+"\n\narith. kite: This is a certain affine image of the main kite, but sitting inside the arithmetic plane.  (The arithmetic plane is simply the domain for the arithmetic kite.)  The two families of lines comprising the room grid are obtained by extending the diagonals of the arithmetic kite and suitably translating.  The 4 families of lines comprising the door grid are obtained by extending the sides of the arithmetic kite and suitable translating.";

	S=S+"\n\ndio lemma:  This displays the region described in the Diophantine Lemma in the monograph.  To see this feature in action, you should select the 'advanced' version of the rational shape parameter entry.  The two rationals to be compared are the ones that are displayed in the top row.  To pick a concrete example, you might try using 3/7 and 7/17.  The triangular region you see when you activate this option shows an idealized version of the region of agreement between the two graphs.  You can see the exact region of agreement by plotting the arithmetic graph using the 'compare' option. The dio lemma display works in 2 settings:  First, if you are comparing two odd rationals.  Second, if you are comparing 2 rationals that are adjacent in the Farey graph.  In principle, we could define the region for any pair of rationals, but the options mentioned are the only ones we use in the monograph.";

	S=S+"\n\ntraps: This displays the two parallelograms discussed in the last chapter of the monograph, in connection with the inheritance of D-hovering components.    A D-hovering component is a component of the arithmetic graph that comes within D>=2 vertical units of the baseline but which does not have a vertex within 1 vertical unit of the baseline. Each rational parameter has an odd predecessor and an even predecessor.  These are two rationals with smaller denominator. When you select a rational parameter (with the advanced version of the selection panel) the two predecessors appear as 2 of the 3 rationals on the next row.) We think of K as being small in comparison to the denominators of all the rationals involved in this constrction.  The basic geometric fact is that the K hovering component is contained in the one displayed parallelogram or the other.   Each displayed parallelogram is contained in the region of agreement between the arithmetic graph for the main rational and the arithmetic graph corresponding to one of the two predecessors.  Hence, the K-hovering components are inherited from simpler arithmetic graphs as long as K is small in comparison to the denominators of all the rationals involved.  This is the proof that there are no large K-hovering components.";

	M.E.setExplain(S);
	M.E.repaint();
    }




}


