import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


 public class ExchangeDynamics {


     public ExchangeDynamics() {}

     public static int match(double[] x,double[] y,double tol) {
	 for(int i=0;i<4;++i) {
	     if(Math.abs(x[i]-y[i])>tol) return(0);
	 }
	 return(1);
     }



     //n is the maximum period

     public static int getPeriod(int n,double A,double[] x) {
	 double[] y=new double[4];
	 for(int i=0;i<4;++i) y[i]=x[i];

	 for(int i=1;i<n;++i) {
	     y=TorusMap.exchange(A,y);
	     if(match(x,y,.00000001)==1) return(i);
	 }
	 return(n);
     }



     //three special polygons

     public static GeneralPath special1() {
	 AffineTransform AT=AffineTransform.getScaleInstance(.5,.5);
	 GeneralPath gp=new GeneralPath();
	 gp.moveTo(0,0);
	 gp.lineTo(0,1);
	 gp.lineTo(1,0);
	 gp.closePath();
	 gp.transform(AT);
	 return(gp);
     }

     public static GeneralPath special2() {
	 AffineTransform AT=AffineTransform.getScaleInstance(.5,.5);
	 GeneralPath gp=new GeneralPath();
	 gp.moveTo(1,0);
	 gp.lineTo(2,0);
	 gp.lineTo(2,1);
	 gp.lineTo(1,2);
	 gp.lineTo(0,2);
	 gp.lineTo(0,1);
	 gp.closePath();
	 gp.transform(AT);
	 return(gp);
     }


     public static GeneralPath special3() {
	 AffineTransform AT=AffineTransform.getScaleInstance(.5,.5);
	 GeneralPath gp=new GeneralPath();
	 gp.moveTo(2,2);
	 gp.lineTo(2,1);
	 gp.lineTo(1,2);
	 gp.closePath();
	 gp.transform(AT);
	 return(gp);
     }


     public static GeneralPath special1(int q,int i,int j) {
	 AffineTransform AT1=AffineTransform.getScaleInstance(1.0/q,1.0/q);
	 AffineTransform AT2=AffineTransform.getTranslateInstance(i,j);
	 GeneralPath gp=special1();
	 gp.transform(AT2);
	 gp.transform(AT1);
	 return(gp);
     }

     public static GeneralPath special2(int q,int i,int j) {
	 AffineTransform AT1=AffineTransform.getScaleInstance(1.0/q,1.0/q);
	 AffineTransform AT2=AffineTransform.getTranslateInstance(i,j);
	 GeneralPath gp=special2();
	 gp.transform(AT2);
	 gp.transform(AT1);
	 return(gp);
     }


     public static GeneralPath special3(int q,int i,int j) {
	 AffineTransform AT1=AffineTransform.getScaleInstance(1.0/q,1.0/q);
	 AffineTransform AT2=AffineTransform.getTranslateInstance(i,j);
	 GeneralPath gp=special3();
	 gp.transform(AT2);
	 gp.transform(AT1);
	 return(gp);
     }




 }




