import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class PinwheelLayering {
    ListenSquare[][] L=new ListenSquare[4][4];
    int[] n=new int[4];
    int x,y;

    public PinwheelLayering(int xx,int yy) {

    this.x=xx;
    this.y=yy;
	for(int i=0;i<4;++i) {
	    for(int j=0;j<4;++j) {
		L[i][j]=new ListenSquare(x+15*i,y+15*j,12,12,Color.white);
	    }
	} 
    n[0]=0;
    n[1]=1;
    n[2]=2;
    n[3]=3;
    }

    public void setMarkers() {
	for(int i=0;i<4;++i) {
	    for(int j=0;j<4;++j) {
		L[i][j].on=0;
	    }
	}

	for(int i=0;i<4;++i) L[i][n[i]].on=1;

    }


    public void render(Graphics2D g) {
	g.setColor(new Color(0,200,200));
	g.fillRect(x,y,60,60);
	g.setColor(Color.white);
	g.drawRect(x,y,60,60);
	setMarkers();
	for(int i=0;i<4;++i) {
	    for(int j=0;j<4;++j) {
		L[i][j].render(g,new Color(50,100,255));
	    }
	}
    }

    public void switchOrder(int a,int b) {

	int temp=n[a];
	int test=-1;
	for(int i=0;i<4;++i) {
	    if(n[i]==b) test=i;
	}

	n[a]=b;
	n[test]=temp;
    }



    public void processMouse(Point X) {
	int[] test=new int[2];
	test[0]=-1;
	test[1]=-1;
	for(int i=0;i<4;++i) {
	    for(int j=0;j<4;++j) {
		if(L[i][j].inside(X)==1) {
		    test[0]=i;
		    test[1]=j;
		}
	    }
	}
	if(test[0]>-1) switchOrder(test[0],test[1]);
    }






}





