import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class DocumentGraph {
    Manager M;
    public DocumentGraph(Manager MM) {
	this.M=MM;
    }


    public void AGPInfo() {

	String S="plot controls";

S=S+"\n\nThis control panel specifies what you plot in the Arithmetic Graph window.  If you don't know what the arithmetic graph is, you can read the documentation for the Arithmetic Graph Window on Billiard King.  In brief, the arithmetic graph is a 2-dimensional plot which encodes the dynamics of the fundamental return map for the outer billiards map.";

S=S+"\n\nNow I'll suppose you know what the arithmetic graph is. Once you have set the option you like, just push 'go' and see what happens. Note: many grid points in the Arithmetic Graph window are not in the arithmetic graph: they have trivial orbits. For these points, nothing will happen if you press 'go'.  You can also select and activate some of the options using the keyboard.  For instance, pressing H is equivalent to selecting the 'forward' option and then pressing 'go'.  The relevant key letter is written after the option on the control panel. ";


	S=S+"\n\nboth: The both option plots both the forwards and backwards orbit of the selected point in the Arithmetic Graph window. You control the number of iterates (always a power of 2 with our interface) using the arrow key labelled 'length'."; 


	S=S+"\n\nforward: The forward option plots the forward orbit of the selected point in the Arithmetic Graph window. You control the number of iterates (always a power of 2 with our interface) using the arrow key labelled 'length'."; 


	S=S+"\n\nbackward: The backward option plots the backward orbit of the selected point in the Arithmetic Graph window. You control the number of iterates as in the forward case."; 


	S=S+"\n\nblock: This option lets you plot all the orbits within a standard rectangle. The rectangle is centered on the point in the window you have selected.  If you select nothing, then the default is (0,0).";

	S=S+"\n\n When you select one of these options, you will call up some auxilliary arrow keys. These arrow keys let you specify how much you plot. In each of the first 3 cases, there is a single arrow key that tells you how much of the orbit you plot.  In the last case, you have two arrow keys which control the width and height of the region you plot.";


	M.E.setExplain(S);

	M.E.repaint();
    }




    public void arithmeticGraphInfo() {

	String S="arithmetic graph window";
	
        S=S+"\n\nThis window draws the arithmetic graph. You activate controls for this window by selecting the 'graph' option on the red 'controls' control panel.  Here we will describe the arithmetic graph, and also explain how you interact with this window";

	S=S+"\n\nThere is a single real number A that controls the shape of the kite. Let R denote the union of the two rays emanating from the top and bottom vertices of the kite and pointing in the positive X direction.  The point (a,b) in the grid on this window corresponds to the points on R of the form";

	S=S+"\n\n(T(a,b),1) and (T(a,b),-1) \n\nwhere T(a,b)=2aA+2b+(e)";

	S=S+"\n\nHere (e) is an infinitesimally small positive value.  In our computations, we take e=.0000001.  The point here is to make sure that we are computing well-defined orbits.";

S=S+"\n\nWe apply the outer billiards map a number of times until our point returns to a point on R, and this point necessarily  corresponds to some T(a0,b0).   We also apply the inverse map a number of times to arrive at a point T(a1,b1).   We connect (a,b) to both (a0,b0) and (a1,b1).  This gives us a small part of the arithmetic graph.  Doing this for all points in the grid gives us the whole arithmetic graph.  The 'block plot' option on the Arithmetic Graph Control Panel makes this plot.";

	S=S+"\n\nAlternatively, we can trace out an orbit by starting with (a,b), then moving to (a1,b1), then moving to a new point (a2,b2) connected to (a1,b1), and so on.  This would give us a kind of 2D plot of the return map.  We could also connect (a,b) to (a0,b0), etc., working our way backwards.  This would give us a kind of 2D plot of the backwards return map.  The 'forwards' and 'backwards' options on the Arithmetic Graph Control Panel let you make this kind of plot, once you have selected (a,b).";

	S=S+"\n\nYou can interact with the Arithmetic Graph window in several ways.  First of all, you can click on grid points, as we already mentioned.  You select points using the middle mouse button. You can scale the window using the left and right mouse buttons. You can resize the window by dragging on the lower left corner.  You can move the selected point using the arrow keys in the upper left corner.  You can also enter a point numerically using the keyboard.";

	S=S+"\n\nThere are a few other auxilliary controls on the top portion of the window.  Once you select a component of the arithmetic graph, you can manipulate it in the following way:";
	S=S+"\n\ndelete: You can delete the component by pushing the delete button.";
	S=S+"\n\nreflect: There is a natural basis for the plane related to the kite with parameter A=p/q.  This basis is given by the vectors\n\n V=(q,-p) and W=(p,((p+q)^2-2p^2)/(2q)). \n\nThe linear part of the reflection maps V to -V and W to W.  There is also a translation part that maps (0,0) to the point (p',q') where pq'-qp'=1 and q'<q.  This affine reflection is not an exact symmetry of the arithmetic graph, but it maps the arithmetic graph into a small tubular neighborhood of itself.";

	M.E.setExplain(S);
	M.E.repaint();
    }






    public void basicInfo() {
	String S="basic settings";

	S=S+"\n\nThis control panel manages the basic settings on the arithmetic graph";
	S=S+"\n\ncoordinate axes.  This toggles the display of coordinate axes on the arithmetic graph window";
	S=S+"\n\nthe Z+Z integer grid.  The arithmetic graph has its vertices in the integer lattice.  This toggles the display of a part of this lattice.  The lattice is about 80x80, and automatically centers on any point you click.";
	S=S+"\n\nmarker: This is a little square that marks the location of the current selected point on the arithmetic graph window.  You should probably always keep this on.";
	S=S+"\n\nLike the some of the other control panels currently in view, this control panel has 2 buttons beside each object.  The left button controls the color and the right button toggles the display.  The one exception to this rule is the 'bgcolor' entry.  Here, the right button does nothing.";


	S=S+"\n\nthe baseline: this is the line of slope -A through the origin. As explained in the monograph, we technically define the baseline to be the line of slope -A through the point (0,-e), where e is an infinitesimally small positive number.";
	S=S+"\n\nrational: This causes the current rational to be displayed in large font on the arithmetic graph window.";

	M.E.setExplain(S);
	M.E.repaint();
    }


}


